#include <SoftwareSerial.h>
#include <Servo.h>

Servo servo01;
Servo servo02;
Servo servo03;
Servo servo04;
Servo servo05;
Servo servo06;

SoftwareSerial Bluetooth(A8, 38); // Arduino(RX, TX) - HC-05 Bluetooth (TX, RX)

int servo1Pos, servo2Pos, servo3Pos, servo4Pos, servo5Pos, servo6Pos; // current position
int servo1PPos, servo2PPos, servo3PPos, servo4PPos, servo5PPos, servo6PPos; // previous position
int servo01SP[50], servo02SP[50], servo03SP[50], servo04SP[50], servo05SP[50], servo06SP[50]; // for storing positions/steps
int recievedPos[50]; // for storing data from app 
int speedDelay = 20;
int index = 0;
int dataIn;
int m = 0;
int start = 90;
int x = 0;
int saves = 0;
int hold = 0;

void setup() 
{
  servo01.attach(13);
  servo02.attach(12);
  servo03.attach(11);
  servo04.attach(10);
  servo05.attach(9);
  servo06.attach(8);
  Bluetooth.begin(9600); // Default baud rate of the Bluetooth module or 38400
  Bluetooth.setTimeout(5);
  delay(20);
  Serial.begin(9600);
  // Move robot arm to initial position
  servo1PPos = start;
  servo01.write(servo1PPos);
  servo2PPos = start;
  servo02.write(servo2PPos);
  servo3PPos = start;
  servo03.write(servo3PPos);
  servo4PPos = start;
  servo04.write(servo4PPos);
  servo5PPos = start;
  servo05.write(servo5PPos);
  servo6PPos = start;
  servo06.write(servo6PPos);
}

void loop() {
  // Check for incoming data
  if (Bluetooth.available() > 0) {
    dataIn = Bluetooth.read();  // Read the data

      Serial.println(dataIn);

    if (dataIn == 0) {
      m = 0;
    }
    if (dataIn == 1) {
      m = 1;
    }
    if (dataIn == 2) {
      m = 2;
    }
    if (dataIn == 3) {
      m = 3;
    }
    if (dataIn == 4) {
      m = 4;
    }
    if (dataIn == 5) {
      m = 5;
    }
    if (dataIn == 6) {
      m = 6;
    }
    if (dataIn == 7) {
      m = 7;
    }
    if (dataIn == 8) {
      m = 8;
    }
    if (dataIn == 9) {
      m = 9;
    }
    if (dataIn == 10) {
      m = 10;
    }
    if (dataIn == 11) {
      m = 11;
    }
    if (dataIn == 12) {
      m = 12;
    }
    if (dataIn == 14) {
      m = 14;
    }
    if (dataIn == 16) {
      m = 16;
    }
    if (dataIn == 17) {
      m = 17;
    }
    if (dataIn == 18) {
      m = 18;
    }
    if (dataIn == 19) {
      m = 19;
    }
    if (dataIn == 20) {
      m = 20;
    }
    if (dataIn == 21) {
      m = 21;
    }
    if (dataIn == 22) {
      m = 22;
    }
    if (dataIn == 23) {
      m = 23;
    }
    if (dataIn == 24) {
      m = 24;
    }
    if (dataIn == 25) {
      m = 25;
    }
    if (dataIn == 26) {
      m = 26;
    }
    if (dataIn == 27) {
      m = 27;
    }
 // If "Run Saved Positions" is Pressed
      if (dataIn == 255){ 
         m = 40;
         Serial.println(m);
          memset(servo01SP, 0, sizeof(servo01SP)); // Clear the array data to 0
          memset(servo02SP, 0, sizeof(servo02SP));
          memset(servo03SP, 0, sizeof(servo03SP));
          memset(servo04SP, 0, sizeof(servo04SP));
          memset(servo05SP, 0, sizeof(servo05SP));
          memset(servo06SP, 0, sizeof(servo06SP));

         while (m == 40) {
            
//          if (Bluetooth.available() > 0) { // tell the code how many positions have been saved.
          saves = Bluetooth.read();
          Serial.print("Saves value: ");
          Serial.println(saves);
          if (saves > 0) {
            hold = 1;
            m = 0;
          }
            //Bluetooth.write(99);
            index = 0;
          }
          if ( hold == 1) {
            for (int i = 0; i <= saves; i++) {
            index++;
            Serial.println("New Loop");
                if (i == 0) {
                servo01SP[i] = start;  // Set start positions.
                servo02SP[i] = start;
                servo03SP[i] = start;
                servo04SP[i] = start;
                servo05SP[i] = start;
                servo06SP[i] = start;
                }
                while (servo01SP[i] <= 0) {
                  servo01SP[i] = Bluetooth.read();  // save position into the array
                  Serial.print("servo01");
                  Serial.println(servo01SP[i]);
                  delay(100);
                }
                    Bluetooth.write(205);
                while (servo02SP[i] <= 0) {    
                  servo02SP[i] = Bluetooth.read();
                  Serial.print("servo02");
                  Serial.println(servo02SP[i]);
                  delay(100);
                }
                    Bluetooth.write(205);
                while (servo03SP[i] <= 0) {
                  servo03SP[i] = Bluetooth.read();
                  Serial.print("servo03");
                  Serial.println(servo03SP[i]);
                  delay(100);
                }
                    Bluetooth.write(205);
                while (servo04SP[i] <= 0) {
                  servo04SP[i] = Bluetooth.read();
                  Serial.print("servo04");
                  Serial.println(servo04SP[i]);
                  delay(100);
                }
                    Bluetooth.write(205);
                while (servo05SP[i] <= 0) {
                  servo05SP[i] = Bluetooth.read();
                  Serial.print("servo05");
                  Serial.println(servo05SP[i]);
                  delay(100);
                }
                    Bluetooth.write(205);
                while (servo06SP[i] <= 0) {
                  servo06SP[i] = Bluetooth.read();
                  Serial.print("servo06");
                  Serial.println(servo06SP[i]);
                  delay(100);
                }
                    Bluetooth.write(205);
            }
                    servo01SP[index] = start;  // Set final positions.
                    servo02SP[index] = start;
                    servo03SP[index] = start;
                    servo04SP[index] = start;
                    servo05SP[index] = start;
                    servo06SP[index] = start;
                    

                      for (int i = 0; i <= index; i++) {
                        Serial.println(index);
                        Serial.print("Servo 1: ");
                        Serial.println(servo01SP[i]);
                        Serial.print("Servo 2: ");
                        Serial.println(servo02SP[i]);
                        Serial.print("Servo 3: ");
                        Serial.println(servo03SP[i]);
                        Serial.print("Servo 4: ");
                        Serial.println(servo04SP[i]);
                        Serial.print("Servo 5: ");
                        Serial.println(servo05SP[i]);
                        Serial.print("Servo 6: ");
                        Serial.println(servo06SP[i]); 
                        Serial.println("Next index");                       
                      }

                    Serial.println("entering runSteps");
                    runSteps();
          }
         //Serial.println(1);
//         int saves = Bluetooth.read();
//         Serial.println(saves);
//         Bluetooth.end();
          
//          for(int j = 0; j <= saves; j++){
//           for(int i = 0; i < 7; i++) {
//           int x = x + 1; 
//           recievedPos[x] = Bluetooth.read();
//           //Bluetooth.write(99);
//           Serial.print(recievedPos[1]);


           }
          
//         }
//        }
     

    // Move robot arm
    // Move servo 1 in positive direction
    while (m == 16) {
      if (Bluetooth.available() > 0) {
        m = Bluetooth.read();
      }
      servo01.write(servo1PPos);
      servo1PPos++;
      delay(speedDelay);
    }
    // Move servo 1 in negative direction
    while (m == 17) {
      if (Bluetooth.available() > 0) {
        m = Bluetooth.read();
      }
      servo01.write(servo1PPos);
      servo1PPos--;
      delay(speedDelay);
    }
    // Move servo 2
    while (m == 19) {
      if (Bluetooth.available() > 0) {
        m = Bluetooth.read();
      }
      servo02.write(servo2PPos);
      servo2PPos++;
      delay(speedDelay);
    }
    while (m == 18) {
      if (Bluetooth.available() > 0) {
        m = Bluetooth.read();
      }
      servo02.write(servo2PPos);
      servo2PPos--;
      delay(speedDelay);
    }
    // Move servo 3
    while (m == 20) {
      if (Bluetooth.available() > 0) {
        m = Bluetooth.read();
      }
      servo03.write(servo3PPos);
      servo3PPos++;
      delay(speedDelay);
    }
    while (m == 21) {
      if (Bluetooth.available() > 0) {
        m = Bluetooth.read();
      }
      servo03.write(servo3PPos);
      servo3PPos--;
      delay(speedDelay);
    }
    // Move servo 4
    while (m == 23) {
      if (Bluetooth.available() > 0) {
        m = Bluetooth.read();
      }
      servo04.write(servo4PPos);
      servo4PPos++;
      delay(speedDelay);
    }
    while (m == 22) {
      if (Bluetooth.available() > 0) {
        m = Bluetooth.read();
      }
      servo04.write(servo4PPos);
      servo4PPos--;
      delay(speedDelay);
    }
    // Move servo 5
    while (m == 25) {
      if (Bluetooth.available() > 0) {
        m = Bluetooth.read();
      }
      servo05.write(servo5PPos);
      servo5PPos++;
      delay(speedDelay);
    }
    while (m == 24) {
      if (Bluetooth.available() > 0) {
        m = Bluetooth.read();
      }
      servo05.write(servo5PPos);
      servo5PPos--;
      delay(speedDelay);
    }
    // Move servo 6
    while (m == 26) {
      if (Bluetooth.available() > 0) {
        m = Bluetooth.read();
      }
      servo06.write(servo6PPos);
      servo6PPos++;
      delay(speedDelay);
    }
    while (m == 27) {
      if (Bluetooth.available() > 0) {
        m = Bluetooth.read();
      }
      servo06.write(servo6PPos);
      servo6PPos--;
      delay(speedDelay);
    }

    // If arm speed slider is changed
    if (dataIn > 101 & dataIn < 250) {
      speedDelay = dataIn / 2; // Change servo speed (delay time)
    }

    // If button "SAVE" is pressed
    if (m == 12) {

      if (index == 0) {
      servo01SP[index] = start;  // Set start positions.
      servo02SP[index] = start;
      servo03SP[index] = start;
      servo04SP[index] = start;
      servo05SP[index] = start;
      servo06SP[index] = start;
      index++;
      }
      
        servo01SP[index] = servo1PPos;  // save position into the array
        servo02SP[index] = servo2PPos;
        servo03SP[index] = servo3PPos;
        servo04SP[index] = servo4PPos;
        servo05SP[index] = servo5PPos;
        servo06SP[index] = servo6PPos;

        Bluetooth.write (servo1PPos); // maybe add slight delays inbetween these so motors arent given the wrong posiiton.
        Bluetooth.write (servo2PPos);
        Bluetooth.write (servo3PPos);
        Bluetooth.write (servo4PPos);
        Bluetooth.write (servo5PPos);
        Bluetooth.write (servo6PPos);
        index++;                        // Increase the array index
        m = 0;
    }

    // If button "RUN" is pressed
    if (m == 14) {

      servo01SP[index] = start;  // Set return positions.
      servo02SP[index] = start;
      servo03SP[index] = start;
      servo04SP[index] = start;
      servo05SP[index] = start;
      servo06SP[index] = start;
      
      runSteps();

      // If button "RESET" is pressed
      if (dataIn == 13) {
        memset(servo01SP, 0, sizeof(servo01SP)); // Clear the array data to 0
        memset(servo02SP, 0, sizeof(servo02SP));
        memset(servo03SP, 0, sizeof(servo03SP));
        memset(servo04SP, 0, sizeof(servo04SP));
        memset(servo05SP, 0, sizeof(servo05SP));
        memset(servo06SP, 0, sizeof(servo06SP));
        index = 0;  // Index to 0
      }
    }
  }
}


// Automatic mode custom function - run the saved steps
void runSteps() {
  while (dataIn != 13) {   // Run the steps over and over again until "RESET" button is pressed
 
      for (int i = 0; i <= index - 1; i++) {  // Run through all steps(index)
        if (Bluetooth.available() > 0) {      // Check for incoming data
          dataIn = Bluetooth.read();
          if ( dataIn == 15) {           // If button "PAUSE" is pressed
            while (dataIn != 14) {         // Wait until "RUN" is pressed again
              if (Bluetooth.available() > 0) {
                dataIn = Bluetooth.read();
                if ( dataIn == 13) {
                  break;
                }
              }
            }
          }
          // If speed slider is changed
          if (dataIn > 100 & dataIn < 250) {
            speedDelay = dataIn / 2; // Change servo speed (delay time)
          }
        }
  
        // Servo 1
        if (servo01SP[i] == servo01SP[i + 1]) {
        }
        if (servo01SP[i] > servo01SP[i + 1]) {
          for ( int j = servo01SP[i]; j >= servo01SP[i + 1]; j--) {
            servo01.write(j);
            delay(speedDelay);
          }
        }
        if (servo01SP[i] < servo01SP[i + 1]) {
          for ( int j = servo01SP[i]; j <= servo01SP[i + 1]; j++) {
            servo01.write(j);
            delay(speedDelay);
          }
        }
  
        // Servo 2
        if (servo02SP[i] == servo02SP[i + 1]) {
        }
        if (servo02SP[i] > servo02SP[i + 1]) {
          for ( int j = servo02SP[i]; j >= servo02SP[i + 1]; j--) {
            servo02.write(j);
            delay(speedDelay);
          }
        }
        if (servo02SP[i] < servo02SP[i + 1]) {
          for ( int j = servo02SP[i]; j <= servo02SP[i + 1]; j++) {
            servo02.write(j);
            delay(speedDelay);
          }
        }
  
        // Servo 3
        if (servo03SP[i] == servo03SP[i + 1]) {
        }
        if (servo03SP[i] > servo03SP[i + 1]) {
          for ( int j = servo03SP[i]; j >= servo03SP[i + 1]; j--) {
            servo03.write(j);
            delay(speedDelay);
          }
        }
        if (servo03SP[i] < servo03SP[i + 1]) {
          for ( int j = servo03SP[i]; j <= servo03SP[i + 1]; j++) {
            servo03.write(j);
            delay(speedDelay);
          }
        }
  
        // Servo 4
        if (servo04SP[i] == servo04SP[i + 1]) {
        }
        if (servo04SP[i] > servo04SP[i + 1]) {
          for ( int j = servo04SP[i]; j >= servo04SP[i + 1]; j--) {
            servo04.write(j);
            delay(speedDelay);
          }
        }
        if (servo04SP[i] < servo04SP[i + 1]) {
          for ( int j = servo04SP[i]; j <= servo04SP[i + 1]; j++) {
            servo04.write(j);
            delay(speedDelay);
          }
        }
  
        // Servo 5
        if (servo05SP[i] == servo05SP[i + 1]) {
        }
        if (servo05SP[i] > servo05SP[i + 1]) {
          for ( int j = servo05SP[i]; j >= servo05SP[i + 1]; j--) {
            servo05.write(j);
            delay(speedDelay);
          }
        }
        if (servo05SP[i] < servo05SP[i + 1]) {
          for ( int j = servo05SP[i]; j <= servo05SP[i + 1]; j++) {
            servo05.write(j);
            delay(speedDelay);
          }
        }
  
        // Servo 6
        if (servo06SP[i] == servo06SP[i + 1]) {
        }
        if (servo06SP[i] > servo06SP[i + 1]) {
          for ( int j = servo06SP[i]; j >= servo06SP[i + 1]; j--) {
            servo06.write(j);
            delay(speedDelay);
          }
        }
        if (servo06SP[i] < servo06SP[i + 1]) {
          for ( int j = servo06SP[i]; j <= servo06SP[i + 1]; j++) {
            servo06.write(j);
            delay(speedDelay);
          }
        }
      }
    }
  }
